<?php

namespace RxConnexionBundle\Form;

use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\Mapping\Entity;
use RxConnexionBundle\Form\DataTransformer\DataTransformer;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\OptionsResolver\OptionsResolver;

class TransferInventoryItemForm extends AbstractType
{
    private $manager;

    public function __construct(ObjectManager $manager) {
        $this->manager = $manager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('action', HiddenType::class, array(
                'mapped' => false,
                'attr' => array(
                    'class' => 'form-action'
                )
            ))
            ->add('transferInventory', HiddenType::class, array(
                'attr' => array(
                    'value' => $options['transferInventory_id']
                )
            ))
            ->add('id', HiddenType::class)
            ->add('created_by', HiddenType::class)
            ->add('created_at', HiddenType::class)
            ->add('updated_by', HiddenType::class)
            ->add('updated_at', HiddenType::class)
            ->add('quantity', TextType::class, array(
                'label' => 'Quantity',
                'label_attr' => array(
                    'class' => 'required middle'
                ),
                'required' => true,
                'attr' => array(
                    'class' => 'amount'
                )
            ))
            ->add('inventory', HiddenType::class)
            ->addEventListener(FormEvents::PRE_SET_DATA, function (FormEvent $event) use ($options) {

                $data = $event->getData();
                $form = $event->getForm();
                $inventory = $data->getInventory();

                $form
                    ->add('inventory_item_description', 'text', array(
                        'mapped' => false,
                        'label' => 'Item',
                        'label_attr' => array(
                            'class' => 'required middle'
                        ),
                        'required' => true,
                        'data' => $inventory ? $inventory->getItem()->getDescription() : '',
                    ));
            });

        $builder->get('inventory')->addModelTransformer(new DataTransformer($this->manager,'RxConnexionBundle:InventoryEntity', false));
        $builder->get('transferInventory')->addModelTransformer(new DataTransformer($this->manager,'RxConnexionBundle:TransferInventoryEntity', false));
    }

    public function getBlockPrefix()
    {
        return 'transferInventoryItem';
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' 	  => 'RxConnexionBundle\Entity\TransferInventoryItemEntity',
            'csrf_protection' => true,
            'csrf_field_name' => '_token',
            // a unique key to help generate the secret token
            'intention'       => 'transferInventoryItemEntity_intention',
            'action'          => 'n'
        ));
    }
}